base-files: add -b (--create-backup) option to sysupgrade, which generates a backup .tar.gz according to the user settings. This will also be reused by LuCI.

SVN-Revision: 29587
This commit is contained in:
Jo-Philipp Wich 2011-12-20 17:25:15 +00:00
parent 77dda8d67a
commit 1c6821b42e
2 changed files with 27 additions and 3 deletions

View file

@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
include $(INCLUDE_DIR)/kernel.mk include $(INCLUDE_DIR)/kernel.mk
PKG_NAME:=base-files PKG_NAME:=base-files
PKG_RELEASE:=98 PKG_RELEASE:=99
PKG_FILE_DEPENDS:=$(PLATFORM_DIR)/ $(GENERIC_PLATFORM_DIR)/base-files/ PKG_FILE_DEPENDS:=$(PLATFORM_DIR)/ $(GENERIC_PLATFORM_DIR)/base-files/
PKG_BUILD_DEPENDS:=opkg/host PKG_BUILD_DEPENDS:=opkg/host

View file

@ -10,6 +10,7 @@ export SAVE_CONFIG=1
export SAVE_OVERLAY=0 export SAVE_OVERLAY=0
export DELAY= export DELAY=
export CONF_IMAGE= export CONF_IMAGE=
export CONF_BACKUP=
export HELP=0 export HELP=0
# parse options # parse options
@ -21,6 +22,7 @@ while [ -n "$1" ]; do
-q) export VERBOSE="$(($VERBOSE - 1))";; -q) export VERBOSE="$(($VERBOSE - 1))";;
-n) export SAVE_CONFIG=0;; -n) export SAVE_CONFIG=0;;
-c) export SAVE_OVERLAY=1;; -c) export SAVE_OVERLAY=1;;
-b|--create-backup) export CONF_BACKUP="$2"; shift;;
-f) export CONF_IMAGE="$2"; shift;; -f) export CONF_IMAGE="$2"; shift;;
-h|--help) export HELP=1; break;; -h|--help) export HELP=1; break;;
-*) -*)
@ -38,7 +40,7 @@ export CONF_TAR=/tmp/sysupgrade.tgz
export ARGV="$*" export ARGV="$*"
export ARGC="$#" export ARGC="$#"
[ -z "$ARGV" -o $HELP -gt 0 ] && { [ -z "$ARGV" -a -z "$CONF_BACKUP" -o $HELP -gt 0 ] && {
cat <<EOF cat <<EOF
Usage: $0 [options] <image file or URL> Usage: $0 [options] <image file or URL>
@ -47,6 +49,10 @@ Options:
-f <config> restore configuration from .tar.gz (file or url) -f <config> restore configuration from .tar.gz (file or url)
-i interactive mode -i interactive mode
-c attempt to preserve all changed files in /etc/ -c attempt to preserve all changed files in /etc/
-b / --create-backup <file>
create .tar.gz of files specified in sysupgrade.conf
then exit. Does not flash an image. If file is '-',
i.e. stdout, verbosity is set to 0 (i.e. quiet).
-n do not save configuration over reflash -n do not save configuration over reflash
-q less verbose -q less verbose
-v more verbose -v more verbose
@ -56,6 +62,17 @@ EOF
exit 1 exit 1
} }
[ -n "$ARGV" -a -n "$CONF_BACKUP" ] && {
cat <<-EOF
-b/--create-backup does not perform a firmware upgrade. Do not
specify both -b and a firmware image.
EOF
exit 1
}
# prevent messages from clobbering the tarball when using stdout
[ "$CONF_BACKUP" = "-" ] && export VERBOSE=0
add_uci_conffiles() { add_uci_conffiles() {
local file="$1" local file="$1"
( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \ ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
@ -85,6 +102,8 @@ sysupgrade_image_check="platform_check_image"
include /lib/upgrade include /lib/upgrade
do_save_conffiles() { do_save_conffiles() {
local conf_tar="${1:-$CONF_TAR}"
[ -z "$(rootfs_type)" ] && { [ -z "$(rootfs_type)" ] && {
echo "Cannot save config while running from ramdisk." echo "Cannot save config while running from ramdisk."
ask_bool 0 "Abort" && exit ask_bool 0 "Abort" && exit
@ -95,9 +114,14 @@ do_save_conffiles() {
v "Saving config files..." v "Saving config files..."
[ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V="" [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
tar c${TAR_V}zf "$CONF_TAR" -T "$CONFFILES" 2>/dev/null tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
} }
if [ -n "$CONF_BACKUP" ]; then
do_save_conffiles "$CONF_BACKUP"
exit $?
fi
type platform_check_image >/dev/null 2>/dev/null || { type platform_check_image >/dev/null 2>/dev/null || {
echo "Firmware upgrade is not implemented for this platform." echo "Firmware upgrade is not implemented for this platform."
exit 1 exit 1